#include <pcl/io/pcd_io.h>
#include <pcl/io/obj_io.h>
#include <limits>
#include <fstream>
#include <vector>
#include <iostream>
#include <pcl/point_types.h>
#include <pcl/point_cloud.h>
#include <pcl/filters/voxel_grid.h>
///

pcl::PointCloud<pcl::PointXYZ>::Ptr cloud (new pcl::PointCloud<pcl::PointXYZ>);

int main(int argc, char **argv)
{
  // Loading .OBJ file
  pcl::io::loadOBJFile (argv[1], *cloud);
  // Downsampling the point cloud
  const float voxel_grid_size = 0.005f;
  pcl::VoxelGrid<pcl::PointXYZ> vox_grid;
  vox_grid.setInputCloud (cloud);
  vox_grid.setLeafSize (voxel_grid_size, voxel_grid_size, voxel_grid_size);
  pcl::PointCloud<pcl::PointXYZ>::Ptr tempCloud (new pcl::PointCloud<pcl::PointXYZ>);
  vox_grid.filter (*tempCloud);
  cloud = tempCloud;
  // Saving needed .PCD file
  pcl::io::savePCDFile ("object_template.pcd", *cloud);

  return (0);
}
